\name{smart.mode.is}
\alias{smart.mode.is}
\title{
Test what mode the smart prediction is in
}
\description{
Test what mode the smart prediction is in
}
\usage{
smart.mode.is(mode.arg)
}
\arguments{
\item{mode.arg}{
a character string, either "read", "write" or "neutral" .
}}
\value{
If \code{mode.arg} is given, then either TRUE or FALSE is returned.
If \code{mode.arg} is not given, then the mode ("neutral", "read" or "write")
is returned.  Usually, the mode is "neutral".
}
\seealso{
put.smart, bs, ns
}
\details{
Smart functions such as \code{bs} and \code{ns} need to know what mode
smart prediction is in. If it is in "write" mode
then the parameters are saved to \code{.smart.prediction}
using \code{put.smart}. If in "read" mode
then the parameters are read in using \code{get.smart}. 
If in "neutral" mode the smart function acts like an ordinary
function.
}
\examples{
# Here is a smart function

my1 <- function(x, minx = min(x))
{
    x <- x
    if(smart.mode.is("read")) {
        smart <- get.smart()
        minx <- smart$minx      # Overwrite its value 
    } else if(smart.mode.is("write"))
              put.smart(list(minx = minx))
    sqrt(x - minx)
}
attr(my1, "smart") <- T

smart.mode.is()   # Returns "neutral"
smart.mode.is(smart.mode.is())  # Returns TRUE
}
%\keyword{smart}
\keyword{models}
\keyword{regression}
\keyword{programming}

% Converted by Sd2Rd version 1.10.
